"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const quidproquo_core_1 = require("quidproquo-core");
const quidproquo_webserver_1 = require("quidproquo-webserver");
const getProcessTransformEventParams = (qpqConfig) => {
    return ({ eventParams: [executeServiceFunctionEvent, context] }) => __awaiter(void 0, void 0, void 0, function* () {
        return (0, quidproquo_core_1.actionResult)(executeServiceFunctionEvent);
    });
};
const getProcessTransformResponseResult = (qpqConfig) => {
    return (payload) => __awaiter(void 0, void 0, void 0, function* () {
        return (0, quidproquo_core_1.actionResult)(payload.response);
    });
};
const getProcessAutoRespond = (qpqConfig) => {
    return (payload) => __awaiter(void 0, void 0, void 0, function* () {
        return (0, quidproquo_core_1.actionResult)(null);
    });
};
const getProcessMatchStory = (qpqConfig) => {
    const serviceFunctions = quidproquo_webserver_1.qpqWebServerUtils.getAllServiceFunctions(qpqConfig);
    return ({ transformedEventParams }) => __awaiter(void 0, void 0, void 0, function* () {
        // Find the most relevant match
        const matchedRoute = serviceFunctions.find((sf) => sf.functionName === transformedEventParams.functionName);
        if (!matchedRoute) {
            return (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ErrorTypeEnum.NotFound, `service function not found [${transformedEventParams.functionName}]`);
        }
        return (0, quidproquo_core_1.actionResult)({
            src: matchedRoute.src,
            runtime: matchedRoute.runtime,
        });
    });
};
exports.default = (qpqConfig) => {
    return {
        [quidproquo_core_1.EventActionType.TransformEventParams]: getProcessTransformEventParams(qpqConfig),
        [quidproquo_core_1.EventActionType.TransformResponseResult]: getProcessTransformResponseResult(qpqConfig),
        [quidproquo_core_1.EventActionType.AutoRespond]: getProcessAutoRespond(qpqConfig),
        [quidproquo_core_1.EventActionType.MatchStory]: getProcessMatchStory(qpqConfig),
    };
};
