"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const quidproquo_core_1 = require("quidproquo-core");
const awsNamingUtils_1 = require("../../../awsNamingUtils");
const quidproquo_core_2 = require("quidproquo-core");
const dynamo_1 = require("../../../logic/dynamo");
const thing_1 = require("../../../logic/dynamo/qpqDynamoOrm/thing");
const getProcessKeyValueStoreQuery = (qpqConfig) => {
    return ({ keyValueStoreName, keyCondition, filterCondition }) => __awaiter(void 0, void 0, void 0, function* () {
        const dynamoTableName = (0, awsNamingUtils_1.getQpqRuntimeResourceNameFromConfig)(keyValueStoreName, qpqConfig, 'kvs');
        const region = quidproquo_core_1.qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig);
        const storeConfig = quidproquo_core_1.qpqCoreUtils.getKeyValueStoreByName(qpqConfig, keyValueStoreName);
        if (!storeConfig) {
            return (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ErrorTypeEnum.NotFound, `Could not find key value store with name "${keyValueStoreName}"`);
        }
        const items = yield (0, dynamo_1.query)(dynamoTableName, region, keyCondition, filterCondition, (0, thing_1.getDynamoTableIndexByConfigAndQuery)(storeConfig, keyCondition));
        return (0, quidproquo_core_2.actionResult)(items);
    });
};
exports.default = (qpqConfig) => ({
    [quidproquo_core_2.KeyValueStoreActionType.Query]: getProcessKeyValueStoreQuery(qpqConfig),
});
