"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.invalidateCache = exports.getInvalidationCallerReference = void 0;
const client_cloudfront_1 = require("@aws-sdk/client-cloudfront");
const crypto_1 = __importDefault(require("crypto"));
const getInvalidationCallerReference = (paths) => {
    const allPaths = paths.join('');
    // All paths as a hash
    const allPathHash = crypto_1.default.createHash('md5').update(allPaths).digest('hex');
    // Unique key is the now time with all paths hash
    return allPathHash + new Date().toISOString();
};
exports.getInvalidationCallerReference = getInvalidationCallerReference;
const invalidateCache = (distributionId, region, paths) => __awaiter(void 0, void 0, void 0, function* () {
    const cloudformation = new client_cloudfront_1.CloudFrontClient({ region });
    const input = {
        DistributionId: distributionId,
        InvalidationBatch: {
            Paths: {
                Quantity: paths.length,
                Items: paths,
            },
            CallerReference: (0, exports.getInvalidationCallerReference)(paths),
        },
    };
    yield cloudformation.send(new client_cloudfront_1.CreateInvalidationCommand(input));
});
exports.invalidateCache = invalidateCache;
