import { KvsKey } from 'quidproquo-core';
export interface PutItemOptions {
    expires?: number;
}
export type KvsKeyValue<T> = {
    key: KvsKey;
    value: T;
};
export type DynamoAttributeType = 'S' | 'N' | 'B';
export declare const readKvsAttributeValue: <T, K extends keyof T>(item: T, key: KvsKey) => KvsKeyValue<T[K]>;
export declare const getDynamoValueTypeFromKvsKey: (key: KvsKey) => DynamoAttributeType;
export declare function putItem<Item>(tableName: string, item: Item, attributes: KvsKey[], options: PutItemOptions, region: string): Promise<void>;
